

Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports System.IO
Imports System.ComponentModel
Imports System.Windows.Markup
Imports System.Xml
Imports AssetsDBModel

Namespace Assets002ns
    ' <summary>
    ' Interaction logic for assets_v8Window.xaml
    ' </summary>
    Class assets_v8Window
        Inherits WindowBase
        Private assetsdbEntities As AssetsDBModel.AssetsDBEntities = Nothing
        Private asset_management2ViewSource As System.Windows.Data.CollectionViewSource = Nothing
        Private asset_management2Query As System.Data.Objects.ObjectQuery(Of asset_management2) = Nothing
        Private maintenance_recordViewSource As System.Windows.Data.CollectionViewSource = Nothing
        Private maintenance_recordQuery As System.Data.Objects.ObjectQuery(Of maintenance_record) = Nothing

        Private Function Getasset_management2Query(ByVal assetsdbEntities As AssetsDBModel.AssetsDBEntities) As System.Data.Objects.ObjectQuery(Of asset_management2)
            ' Auto generated code
            Dim asset_management2Query As System.Data.Objects.ObjectQuery(Of asset_management2) = assetsdbEntities.asset_management2
            'Update the query to include related table data in "maintenance_record. You can modify this code as needed.
            asset_management2Query = asset_management2Query.Include("maintenance_record")
            ' Returns an ObjectQuery.
            Return asset_management2Query
        End Function

        Private Function Getmaintenance_recordQuery(ByVal assetsdbEntities As AssetsDBModel.AssetsDBEntities) As System.Data.Objects.ObjectQuery(Of maintenance_record)
            ' Auto generated code
            Dim maintenance_recordQuery As System.Data.Objects.ObjectQuery(Of maintenance_record) = assetsdbEntities.maintenance_record
            'Update the query to include related table data in "maintenance_record". You can modify this code as needed.
            maintenance_recordQuery = maintenance_recordQuery.Include("asset_management2")
            ' Returns an ObjectQuery.
            Return maintenance_recordQuery
        End Function

        Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
            assetsdbEntities = New AssetsDBModel.AssetsDBEntities()
            ' Load data into asset_management2. You can modify this code as needed.
            asset_management2ViewSource = DirectCast(Me.FindResource("asset_management2ViewSource"), System.Windows.Data.CollectionViewSource)
            asset_management2Query = Me.Getasset_management2Query(assetsdbEntities)
            asset_management2ViewSource.Source = asset_management2Query.Execute(System.Data.Objects.MergeOption.PreserveChanges)
            maintenance_recordViewSource = DirectCast(Me.FindResource("maintenance_recordViewSource"), System.Windows.Data.CollectionViewSource)
            maintenance_recordQuery = Me.Getmaintenance_recordQuery(assetsdbEntities)
            maintenance_recordViewSource.Source = maintenance_recordQuery.Execute(System.Data.Objects.MergeOption.PreserveChanges)
            Me.ReBind()
        End Sub

        Public Sub New()
            ' This call is required by the designer.
            InitializeComponent()

            ' Add any initialization after the InitializeComponent() call.
        End Sub

        Protected Friend Sub Show_Toolbar()
            If Me.toolBarUserControl1.IsVisible Then
                Me.toolBarUserControl1.Visibility = Windows.Visibility.Hidden
            Else
                Me.toolBarUserControl1.Visibility = Windows.Visibility.Visible
            End If
        End Sub

        Protected Friend Overrides ReadOnly Property TotalRecords() As Integer
            Get
                Dim currentTable = assetsdbEntities.asset_management2.AsQueryable()
                Dim maxRecords As Integer = currentTable.Count()
                Return maxRecords
            End Get
        End Property

        Protected Friend Overrides Property CurrentRecordPosition() As Double
            Get
                If asset_management2ViewSource IsNot Nothing Then
                    Return CDbl(asset_management2ViewSource.View.CurrentPosition)
                Else
                    Return 0.0

                End If
            End Get

            Set(ByVal value As Double)
                Dim newPosition As Integer = CInt(Math.Truncate(value))
                Dim currentTable = assetsdbEntities.asset_management2.AsQueryable()
                Dim maxRecords As Integer = currentTable.Count() - 1

                If newPosition > maxRecords Then
                    newPosition = maxRecords
                End If

                asset_management2ViewSource.View.MoveCurrentToPosition(newPosition)
                NotifyPropertyChanged("CurrentRecordPosition")
            End Set
        End Property

        Protected Friend Overrides Sub SaveRecords()
            Try
                Me.assetsdbEntities.SaveChanges()
            Catch generatedExceptionName As Exception
                'Error handling                
                Throw
            End Try
        End Sub

        Protected Friend Overrides Sub NewRecord()
            Try
                Dim entity = assetsdbEntities.CreateObject(Of asset_management2)()
                assetsdbEntities.AddToasset_management2(entity)
            Catch generatedExceptionName As Exception
                'Error Handling
                Throw
            End Try

            Me.SaveRecords()
            asset_management2ViewSource.Source = asset_management2Query.Execute(System.Data.Objects.MergeOption.PreserveChanges)
            asset_management2ViewSource.View.MoveCurrentToLast()

            NotifyPropertyChanged("TotalRecords")
        End Sub

        Protected Friend Overrides Sub DeleteCurrentRecord()
            Try
                Dim entity = asset_management2ViewSource.View.CurrentItem
                assetsdbEntities.DeleteObject(entity)
            Catch generatedExceptionName As Exception
                'Error Handling        
                Throw
            End Try
            Me.SaveRecords()
            asset_management2ViewSource.View.Refresh()
            NotifyPropertyChanged("TotalRecords")
        End Sub

        Protected Friend Overrides Sub MoveToNextRecord()
            If asset_management2ViewSource.View.CurrentPosition < DirectCast(asset_management2ViewSource.View, CollectionView).Count - 1 Then
                asset_management2ViewSource.View.MoveCurrentToNext()
            End If
            Me.SaveRecords()
            NotifyPropertyChanged("CurrentRecordPosition")
        End Sub

        Protected Friend Overrides Sub MoveToPreviousRecord()
            If asset_management2ViewSource.View.CurrentPosition > 0 Then
                asset_management2ViewSource.View.MoveCurrentToPrevious()
            End If
            Me.SaveRecords()
            NotifyPropertyChanged("CurrentRecordPosition")
        End Sub

        Protected Friend Overrides Sub ReBind()
            Me.Bind_menu_asset_management2__category()
            Me.chkbx_asset_management2__book_value_RebindCheckBoxes()
            Me.radio_asset_management2__category_RebindRadioButtons()
            Me.chkbx_asset_management2__category_RebindCheckBoxes()
            Me.radio_asset_management2__category3_RebindRadioButtons()
            Me.chkbx_asset_management2__category4_RebindCheckBoxes()
            Me.Bind_menu_asset_management2__category5()
            Me.radio_asset_management2__category6_RebindRadioButtons()
            Me.chkbx_maintenance_record__maint_condition3_RebindCheckBoxes()
            Me.radio_maintenance_record__maint_condition4_RebindRadioButtons()
        End Sub

        Private Sub Bind_menu_asset_management2__category()
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If data.category IsNot Nothing Then
                Dim category As String = data.category.TrimStart(" "c)
                Dim i As Integer = 0
                For Each item As XmlElement In menu_asset_management2__category.Items
                    If item.InnerText.Equals(category) Then
                        menu_asset_management2__category.SelectedIndex = i
                        Return
                    End If
                    i += 1
                Next
            End If
        End Sub

        Private Sub menu_asset_management2__category_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
            If asset_management2ViewSource IsNot Nothing Then
                Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
                If item.category IsNot Nothing Then
                    item.category = DirectCast(menu_asset_management2__category.SelectedItem, XmlElement).InnerText
                    Me.SaveRecords()
                End If
            End If
        End Sub

        Private Sub chkbx_asset_management2__book_value_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            item.book_value = 1
            Me.SaveRecords()
        End Sub

        Private Sub chkbx_asset_management2__book_value_UnChecked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            item.book_value = 0
            Me.SaveRecords()
        End Sub

        Public Sub chkbx_asset_management2__book_value_RebindCheckBoxes()
            'Uncheck if they haven't been set 
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If data IsNot Nothing Then
                If data.book_value Is Nothing Then
                    Return
                End If
                Dim expectedNumber As Decimal = 1
                If data.book_value.[GetType]().Equals(GetType(Decimal)) Then
                    If data.book_value.HasValue Then
                        chkbx_asset_management2__book_value_0.IsChecked = data.book_value.Equals(expectedNumber)
                    Else
                        chkbx_asset_management2__book_value_0.IsChecked = False
                   End If
                End If
            End If
        End Sub

        Private Sub radio_asset_management2__category_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim rdButton As RadioButton = DirectCast(sender, RadioButton)
            Dim data As String = TryCast(rdButton.Content, String)

            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            item.category = data

            Me.SaveRecords()
        End Sub
        Public Sub radio_asset_management2__category_RebindRadioButtons()
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)

            If data IsNot Nothing Then
                If data.category IsNot Nothing Then
                Select Case data.category
                    Case "Office Furniture"
                        radio_asset_management2__category_0.IsChecked = True
                        Exit Select
                    Case "Computers"
                        radio_asset_management2__category_1.IsChecked = True
                        Exit Select
                    Case "Telephones"
                        radio_asset_management2__category_2.IsChecked = True
                        Exit Select
                    Case "-"
                        radio_asset_management2__category_3.IsChecked = True
                        Exit Select
                End Select
                End If
            End If
        End Sub

        Private Sub chkbx_asset_management2__category_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim data As String = TryCast(chkBox.Content, String)
            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If item.category Is Nothing Then
                Return
            End If
            If Not item.category.Contains(data) Then
                item.category += vbLf & data
            End If
            Me.SaveRecords()
        End Sub

        Private Sub chkbx_asset_management2__category_UnChecked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim data As String = TryCast(chkBox.Content, String)
            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If item.category Is Nothing Then
                Return
            End If
            If item.category.Contains(data) Then
                item.category.Replace(vbLf & data, String.Empty)
            End If
            Me.SaveRecords()
        End Sub

        Public Sub chkbx_asset_management2__category_RebindCheckBoxes()
            'Uncheck if they haven't been set 
            chkbx_asset_management2__category_0.IsChecked = False
            chkbx_asset_management2__category_1.IsChecked = False
            chkbx_asset_management2__category_2.IsChecked = False
            chkbx_asset_management2__category_3.IsChecked = False
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If data IsNot Nothing Then
                If data.category Is Nothing Then
                    Return
                End If
                Dim names As String() = data.category.Split(ControlChars.Lf)
                For i As Integer = 0 To names.Length - 1

                    Select Case names(i).TrimStart(" "c)
                    Case "Office Furniture"
                        chkbx_asset_management2__category_0.IsChecked = True
                        Exit Select
                    Case "Computers"
                        chkbx_asset_management2__category_1.IsChecked = True
                        Exit Select
                    Case "Telephones"
                        chkbx_asset_management2__category_2.IsChecked = True
                        Exit Select
                    Case "-"
                        chkbx_asset_management2__category_3.IsChecked = True
                        Exit Select
                            'default:
                            '    throw new ApplicationException(" error ");
                    End Select
                Next
            End If
        End Sub

        Private Sub radio_asset_management2__category3_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim rdButton As RadioButton = DirectCast(sender, RadioButton)
            Dim data As String = TryCast(rdButton.Content, String)

            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            item.category = data

            Me.SaveRecords()
        End Sub
        Public Sub radio_asset_management2__category3_RebindRadioButtons()
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)

            If data IsNot Nothing Then
                If data.category IsNot Nothing Then
                Select Case data.category
                    Case "Office Furniture"
                        radio_asset_management2__category3_0.IsChecked = True
                        Exit Select
                    Case "Computers"
                        radio_asset_management2__category3_1.IsChecked = True
                        Exit Select
                    Case "Telephones"
                        radio_asset_management2__category3_2.IsChecked = True
                        Exit Select
                    Case "-"
                        radio_asset_management2__category3_3.IsChecked = True
                        Exit Select
                End Select
                End If
            End If
        End Sub

        Private Sub chkbx_asset_management2__category4_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim data As String = TryCast(chkBox.Content, String)
            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If item.category Is Nothing Then
                Return
            End If
            If Not item.category.Contains(data) Then
                item.category += vbLf & data
            End If
            Me.SaveRecords()
        End Sub

        Private Sub chkbx_asset_management2__category4_UnChecked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim data As String = TryCast(chkBox.Content, String)
            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If item.category Is Nothing Then
                Return
            End If
            If item.category.Contains(data) Then
                item.category.Replace(vbLf & data, String.Empty)
            End If
            Me.SaveRecords()
        End Sub

        Public Sub chkbx_asset_management2__category4_RebindCheckBoxes()
            'Uncheck if they haven't been set 
            chkbx_asset_management2__category4_0.IsChecked = False
            chkbx_asset_management2__category4_1.IsChecked = False
            chkbx_asset_management2__category4_2.IsChecked = False
            chkbx_asset_management2__category4_3.IsChecked = False
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If data IsNot Nothing Then
                If data.category Is Nothing Then
                    Return
                End If
                Dim names As String() = data.category.Split(ControlChars.Lf)
                For i As Integer = 0 To names.Length - 1

                    Select Case names(i).TrimStart(" "c)
                    Case "Office Furniture"
                        chkbx_asset_management2__category4_0.IsChecked = True
                        Exit Select
                    Case "Computers"
                        chkbx_asset_management2__category4_1.IsChecked = True
                        Exit Select
                    Case "Telephones"
                        chkbx_asset_management2__category4_2.IsChecked = True
                        Exit Select
                    Case "-"
                        chkbx_asset_management2__category4_3.IsChecked = True
                        Exit Select
                            'default:
                            '    throw new ApplicationException(" error ");
                    End Select
                Next
            End If
        End Sub

        Private Sub Bind_menu_asset_management2__category5()
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            If data.category IsNot Nothing Then
                Dim category As String = data.category.TrimStart(" "c)
                Dim i As Integer = 0
                For Each item As XmlElement In menu_asset_management2__category5.Items
                    If item.InnerText.Equals(category) Then
                        menu_asset_management2__category5.SelectedIndex = i
                        Return
                    End If
                    i += 1
                Next
            End If
        End Sub

        Private Sub menu_asset_management2__category5_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
            If asset_management2ViewSource IsNot Nothing Then
                Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
                If item.category IsNot Nothing Then
                    item.category = DirectCast(menu_asset_management2__category5.SelectedItem, XmlElement).InnerText
                    Me.SaveRecords()
                End If
            End If
        End Sub

        Private Sub radio_asset_management2__category6_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim rdButton As RadioButton = DirectCast(sender, RadioButton)
            Dim data As String = TryCast(rdButton.Content, String)

            Dim item = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)
            item.category = data

            Me.SaveRecords()
        End Sub
        Public Sub radio_asset_management2__category6_RebindRadioButtons()
            Dim data = DirectCast(asset_management2ViewSource.View.CurrentItem, asset_management2)

            If data IsNot Nothing Then
                If data.category IsNot Nothing Then
                Select Case data.category
                    Case "Office Furniture"
                        radio_asset_management2__category6_0.IsChecked = True
                        Exit Select
                    Case "Computers"
                        radio_asset_management2__category6_1.IsChecked = True
                        Exit Select
                    Case "Telephones"
                        radio_asset_management2__category6_2.IsChecked = True
                        Exit Select
                    Case "Table"
                        radio_asset_management2__category6_3.IsChecked = True
                        Exit Select
                    Case "Chair"
                        radio_asset_management2__category6_4.IsChecked = True
                        Exit Select
                    Case "Router"
                        radio_asset_management2__category6_5.IsChecked = True
                        Exit Select
                End Select
                End If
            End If
        End Sub

        Private Sub chkbx_maintenance_record__maint_condition3_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim data As String = TryCast(chkBox.Content, String)
            Dim item = DirectCast(maintenance_recordViewSource.View.CurrentItem, maintenance_record)
            If item.maint_condition3 Is Nothing Then
                Return
            End If
            If Not item.maint_condition3.Contains(data) Then
                item.maint_condition3 += vbLf & data
            End If
            Me.SaveRecords()
        End Sub

        Private Sub chkbx_maintenance_record__maint_condition3_UnChecked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim chkBox As CheckBox = DirectCast(sender, CheckBox)
            Dim data As String = TryCast(chkBox.Content, String)
            Dim item = DirectCast(maintenance_recordViewSource.View.CurrentItem, maintenance_record)
            If item.maint_condition3 Is Nothing Then
                Return
            End If
            If item.maint_condition3.Contains(data) Then
                item.maint_condition3.Replace(vbLf & data, String.Empty)
            End If
            Me.SaveRecords()
        End Sub

        Public Sub chkbx_maintenance_record__maint_condition3_RebindCheckBoxes()
            'Uncheck if they haven't been set 
            Dim data = DirectCast(maintenance_recordViewSource.View.CurrentItem, maintenance_record)
            If data IsNot Nothing Then
                If data.maint_condition3 Is Nothing Then
                    Return
                End If
                Dim names As String() = data.maint_condition3.Split(ControlChars.Lf)
                For i As Integer = 0 To names.Length - 1

                Next
            End If
        End Sub

        Private Sub radio_maintenance_record__maint_condition4_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim rdButton As RadioButton = DirectCast(sender, RadioButton)
            Dim data As String = TryCast(rdButton.Content, String)

            Dim item = DirectCast(maintenance_recordViewSource.View.CurrentItem, maintenance_record)
            item.maint_condition4 = data

            Me.SaveRecords()
        End Sub
        Public Sub radio_maintenance_record__maint_condition4_RebindRadioButtons()
            Dim data = DirectCast(maintenance_recordViewSource.View.CurrentItem, maintenance_record)

            If data IsNot Nothing Then
                If data.maint_condition4 IsNot Nothing Then
                End If
            End If
        End Sub


    End Class
End Namespace
